"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (Object.hasOwnProperty.call(mod, k)) result[k] = mod[k];
    result["default"] = mod;
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
const compression_1 = require("./compression");
const Keystore_1 = require("./Keystore");
const fs = __importStar(require("fs"));
const ks = new Keystore_1.Keystore('/tmp/keystore.json');
function main() {
    return __awaiter(this, void 0, void 0, function* () {
        const key = ks.genKeyPair('N0CALL');
        const strings = fs.readFileSync('../../Branger_Briz/twitter-transfer-learning/data/text/realdonaldtrump.txt')
            .toString('utf8')
            .split('\n');
        const totals = { one: [], both: [] };
        for (let message of strings) {
            const results = yield compare(message, key.private);
            totals.one.push(results.one);
            totals.both.push(results.both);
            console.log(`one: ${results.one}, two: ${results.both}`);
        }
        console.log(`Averages -> one: ${mean(totals.one)}, both: ${mean(totals.both)}`);
    });
}
function compare(message, privKey) {
    return __awaiter(this, void 0, void 0, function* () {
        let one = Buffer.concat([
            ks.sign(message, privKey),
            yield compression_1.compress(Buffer.from(message, 'utf8'))
        ]);
        let both = yield compression_1.compress(Buffer.concat([
            ks.sign(message, privKey),
            yield compression_1.compress(Buffer.from(message, 'utf8'))
        ]));
        return { one: one.length, both: both.length };
    });
}
function mean(arr) {
    if (arr.length == 0)
        return null;
    return arr.reduce((total, value) => total + value) / arr.length;
}
main().catch(console.error);
//# sourceMappingURL=compression-test.js.map